#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_dJIK2x32x32NN2x4x32_a1_b1
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=N, MB=2, NB=32, KB=32, 
 * lda=0, ldb=0, ldc=0, mu=2, nu=4, ku=32, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.3)
 */
{
   const double *stM = A + 2;
   const double *stN = B + (((ldb) << 5));
   const double *pfA = A + lda*M;
   const int incAk = (lda);
   const int incAm = 2 - (((lda) << 5)), incAn = -2;
   #define incBk 32
   const int incBm = -32, incBn = (((ldb) << 2));
   #define incCm 2
   const int incCn = (((ldc) << 2)) - 2;
   double *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc);
   const double *pA0=A;
   const double *pB0=B, *pB1=pB0+(ldb), *pB2=pB1+(ldb), *pB3=pB2+(ldb);
   register int k;
   register double rA0, rA1;
   register double rB0, rB1, rB2, rB3;
   register double rC0_0, rC1_0, rC0_1, rC1_1, rC0_2, rC1_2, rC0_3, rC1_3;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+8);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+24);
      pfA += lda;
      rC0_0 = *pC0;
      rC1_0 = pC0[1];
      rC0_1 = *pC1;
      rC1_1 = pC1[1];
      rC0_2 = *pC2;
      rC1_2 = pC2[1];
      rC0_3 = *pC3;
      rC1_3 = pC3[1];
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = pA0[1];
      rB1 = *pB1;
      rB2 = *pB2;
      rB3 = *pB3;
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[1];
      rA1 = pA0[1];
      rB1 = pB1[1];
      rB2 = pB2[1];
      rB3 = pB3[1];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[2];
      rA1 = pA0[1];
      rB1 = pB1[2];
      rB2 = pB2[2];
      rB3 = pB3[2];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[3];
      rA1 = pA0[1];
      rB1 = pB1[3];
      rB2 = pB2[3];
      rB3 = pB3[3];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[4];
      rA1 = pA0[1];
      rB1 = pB1[4];
      rB2 = pB2[4];
      rB3 = pB3[4];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[5];
      rA1 = pA0[1];
      rB1 = pB1[5];
      rB2 = pB2[5];
      rB3 = pB3[5];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[6];
      rA1 = pA0[1];
      rB1 = pB1[6];
      rB2 = pB2[6];
      rB3 = pB3[6];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[7];
      rA1 = pA0[1];
      rB1 = pB1[7];
      rB2 = pB2[7];
      rB3 = pB3[7];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[8];
      rA1 = pA0[1];
      rB1 = pB1[8];
      rB2 = pB2[8];
      rB3 = pB3[8];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[9];
      rA1 = pA0[1];
      rB1 = pB1[9];
      rB2 = pB2[9];
      rB3 = pB3[9];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[10];
      rA1 = pA0[1];
      rB1 = pB1[10];
      rB2 = pB2[10];
      rB3 = pB3[10];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[11];
      rA1 = pA0[1];
      rB1 = pB1[11];
      rB2 = pB2[11];
      rB3 = pB3[11];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[12];
      rA1 = pA0[1];
      rB1 = pB1[12];
      rB2 = pB2[12];
      rB3 = pB3[12];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[13];
      rA1 = pA0[1];
      rB1 = pB1[13];
      rB2 = pB2[13];
      rB3 = pB3[13];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[14];
      rA1 = pA0[1];
      rB1 = pB1[14];
      rB2 = pB2[14];
      rB3 = pB3[14];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[15];
      rA1 = pA0[1];
      rB1 = pB1[15];
      rB2 = pB2[15];
      rB3 = pB3[15];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[16];
      rA1 = pA0[1];
      rB1 = pB1[16];
      rB2 = pB2[16];
      rB3 = pB3[16];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[17];
      rA1 = pA0[1];
      rB1 = pB1[17];
      rB2 = pB2[17];
      rB3 = pB3[17];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[18];
      rA1 = pA0[1];
      rB1 = pB1[18];
      rB2 = pB2[18];
      rB3 = pB3[18];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[19];
      rA1 = pA0[1];
      rB1 = pB1[19];
      rB2 = pB2[19];
      rB3 = pB3[19];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[20];
      rA1 = pA0[1];
      rB1 = pB1[20];
      rB2 = pB2[20];
      rB3 = pB3[20];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[21];
      rA1 = pA0[1];
      rB1 = pB1[21];
      rB2 = pB2[21];
      rB3 = pB3[21];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[22];
      rA1 = pA0[1];
      rB1 = pB1[22];
      rB2 = pB2[22];
      rB3 = pB3[22];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[23];
      rA1 = pA0[1];
      rB1 = pB1[23];
      rB2 = pB2[23];
      rB3 = pB3[23];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[24];
      rA1 = pA0[1];
      rB1 = pB1[24];
      rB2 = pB2[24];
      rB3 = pB3[24];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[25];
      rA1 = pA0[1];
      rB1 = pB1[25];
      rB2 = pB2[25];
      rB3 = pB3[25];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[26];
      rA1 = pA0[1];
      rB1 = pB1[26];
      rB2 = pB2[26];
      rB3 = pB3[26];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[27];
      rA1 = pA0[1];
      rB1 = pB1[27];
      rB2 = pB2[27];
      rB3 = pB3[27];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[28];
      rA1 = pA0[1];
      rB1 = pB1[28];
      rB2 = pB2[28];
      rB3 = pB3[28];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[29];
      rA1 = pA0[1];
      rB1 = pB1[29];
      rB2 = pB2[29];
      rB3 = pB3[29];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[30];
      rA1 = pA0[1];
      rB1 = pB1[30];
      rB2 = pB2[30];
      rB3 = pB3[30];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      pA0 += incAk;
      rA0 = *pA0;
      rB0 = pB0[31];
      rA1 = pA0[1];
      rB1 = pB1[31];
      rB2 = pB2[31];
      rB3 = pB3[31];
      rC0_0 += rA0 * rB0;
      rC1_0 += rA1 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC0_3 += rA0 * rB3;
      rC1_3 += rA1 * rB3;
      pA0 += incAk;
      pB0 += incBk;
      pB1 += incBk;
      pB2 += incBk;
      pB3 += incBk;
      *pC0 = rC0_0;
      pC0[1] = rC1_0;
      *pC1 = rC0_1;
      pC1[1] = rC1_1;
      *pC2 = rC0_2;
      pC2[1] = rC1_2;
      *pC3 = rC0_3;
      pC3[1] = rC1_3;
      pC0 += incCm;
      pC1 += incCm;
      pC2 += incCm;
      pC3 += incCm;
      pA0 += incAm;
      pB0 += incBm;
      pB1 += incBm;
      pB2 += incBm;
      pB3 += incBm;
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pA0 += incAn;
      pB0 += incBn;
      pB1 += incBn;
      pB2 += incBn;
      pB3 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_dJIK32x32x32NN0x0x0_a1_b1
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=N, MB=32, NB=32, KB=32, 
 * lda=0, ldb=0, ldc=0, mu=5, nu=4, ku=32, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.3)
 */
{
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + 30;
   const double *stN = B + (((ldb) << 5));
   const double *pfA = A + lda*M;
   const int incAk = (lda);
   const int incAm = 5 - (((lda) << 5)), incAn = -30;
   #define incBk 32
   const int incBm = -32, incBn = (((ldb) << 2));
   #define incCm 5
   const int incCn = (((ldc) << 2)) - 30;
   double *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc);
   const double *pA0=A;
   const double *pB0=B, *pB1=pB0+(ldb), *pB2=pB1+(ldb), *pB3=pB2+(ldb);
   register int k;
   register double rA0, rA1, rA2, rA3, rA4;
   register double rB0, rB1, rB2, rB3;
   register double rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC0_1, rC1_1, rC2_1, rC3_1, rC4_1, rC0_2, rC1_2, rC2_2, rC3_2, rC4_2, rC0_3, rC1_3, rC2_3, rC3_3, rC4_3;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+8);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+24);
      pfA += lda;
      do /* M-loop */
      {
         rC0_0 = *pC0;
         rC1_0 = pC0[1];
         rC2_0 = pC0[2];
         rC3_0 = pC0[3];
         rC4_0 = pC0[4];
         rC0_1 = *pC1;
         rC1_1 = pC1[1];
         rC2_1 = pC1[2];
         rC3_1 = pC1[3];
         rC4_1 = pC1[4];
         rC0_2 = *pC2;
         rC1_2 = pC2[1];
         rC2_2 = pC2[2];
         rC3_2 = pC2[3];
         rC4_2 = pC2[4];
         rC0_3 = *pC3;
         rC1_3 = pC3[1];
         rC2_3 = pC3[2];
         rC3_3 = pC3[3];
         rC4_3 = pC3[4];
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rA4 = pA0[4];
         rB1 = *pB1;
         rB2 = *pB2;
         rC0_0 += rA0 * rB0;
         rB3 = *pB3;
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[1];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rA4 = pA0[4];
         rB1 = pB1[1];
         rB2 = pB2[1];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[2];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rA4 = pA0[4];
         rB1 = pB1[2];
         rB2 = pB2[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[2];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[3];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rA4 = pA0[4];
         rB1 = pB1[3];
         rB2 = pB2[3];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[3];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[4];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rA4 = pA0[4];
         rB1 = pB1[4];
         rB2 = pB2[4];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[4];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[5];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rA4 = pA0[4];
         rB1 = pB1[5];
         rB2 = pB2[5];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[5];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[6];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rA4 = pA0[4];
         rB1 = pB1[6];
         rB2 = pB2[6];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[6];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[7];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rA4 = pA0[4];
         rB1 = pB1[7];
         rB2 = pB2[7];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[7];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[8];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rA4 = pA0[4];
         rB1 = pB1[8];
         rB2 = pB2[8];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[8];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[9];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rA4 = pA0[4];
         rB1 = pB1[9];
         rB2 = pB2[9];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[9];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[10];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rA4 = pA0[4];
         rB1 = pB1[10];
         rB2 = pB2[10];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[10];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[11];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rA4 = pA0[4];
         rB1 = pB1[11];
         rB2 = pB2[11];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[11];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[12];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rA4 = pA0[4];
         rB1 = pB1[12];
         rB2 = pB2[12];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[12];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[13];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rA4 = pA0[4];
         rB1 = pB1[13];
         rB2 = pB2[13];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[13];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[14];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rA4 = pA0[4];
         rB1 = pB1[14];
         rB2 = pB2[14];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[14];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[15];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rA4 = pA0[4];
         rB1 = pB1[15];
         rB2 = pB2[15];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[15];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[16];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rA4 = pA0[4];
         rB1 = pB1[16];
         rB2 = pB2[16];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[16];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[17];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rA4 = pA0[4];
         rB1 = pB1[17];
         rB2 = pB2[17];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[17];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[18];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rA4 = pA0[4];
         rB1 = pB1[18];
         rB2 = pB2[18];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[18];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[19];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rA4 = pA0[4];
         rB1 = pB1[19];
         rB2 = pB2[19];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[19];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[20];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rA4 = pA0[4];
         rB1 = pB1[20];
         rB2 = pB2[20];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[20];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[21];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rA4 = pA0[4];
         rB1 = pB1[21];
         rB2 = pB2[21];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[21];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[22];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rA4 = pA0[4];
         rB1 = pB1[22];
         rB2 = pB2[22];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[22];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[23];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rA4 = pA0[4];
         rB1 = pB1[23];
         rB2 = pB2[23];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[23];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[24];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rA4 = pA0[4];
         rB1 = pB1[24];
         rB2 = pB2[24];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[24];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[25];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rA4 = pA0[4];
         rB1 = pB1[25];
         rB2 = pB2[25];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[25];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[26];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rA4 = pA0[4];
         rB1 = pB1[26];
         rB2 = pB2[26];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[26];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[27];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rA4 = pA0[4];
         rB1 = pB1[27];
         rB2 = pB2[27];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[27];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[28];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rA4 = pA0[4];
         rB1 = pB1[28];
         rB2 = pB2[28];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[28];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[29];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rA4 = pA0[4];
         rB1 = pB1[29];
         rB2 = pB2[29];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[29];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[30];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rA4 = pA0[4];
         rB1 = pB1[30];
         rB2 = pB2[30];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[30];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[31];
         rA1 = pA0[1];
         rA2 = pA0[2];
         rA3 = pA0[3];
         rA4 = pA0[4];
         rB1 = pB1[31];
         rB2 = pB2[31];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[31];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         pA0 += incAk;
         pB0 += incBk;
         pB1 += incBk;
         pB2 += incBk;
         pB3 += incBk;
         *pC0 = rC0_0;
         pC0[1] = rC1_0;
         pC0[2] = rC2_0;
         pC0[3] = rC3_0;
         pC0[4] = rC4_0;
         *pC1 = rC0_1;
         pC1[1] = rC1_1;
         pC1[2] = rC2_1;
         pC1[3] = rC3_1;
         pC1[4] = rC4_1;
         *pC2 = rC0_2;
         pC2[1] = rC1_2;
         pC2[2] = rC2_2;
         pC2[3] = rC3_2;
         pC2[4] = rC4_2;
         *pC3 = rC0_3;
         pC3[1] = rC1_3;
         pC3[2] = rC2_3;
         pC3[3] = rC3_3;
         pC3[4] = rC4_3;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pC3 += incCm;
         pA0 += incAm;
         pB0 += incBm;
         pB1 += incBm;
         pB2 += incBm;
         pB3 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pA0 += incAn;
      pB0 += incBn;
      pB1 += incBn;
      pB2 += incBn;
      pB3 += incBn;
   }
   while(pB0 != stN);
   ATL_dJIK2x32x32NN2x4x32_a1_b1(2, 32, 32, alpha, ca + 30, lda, cb, ldb, beta, cc + 30, ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
